'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

exports.evaluatePaths = evaluatePaths;
exports.getAppNameFromPath = getAppNameFromPath;
exports.evalPathParams = evalPathParams;

var _pathToRegexp = require('path-to-regexp');

var _pathToRegexp2 = _interopRequireDefault(_pathToRegexp);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function evaluatePaths(apps) {
  return (0, _keys2.default)(apps || {}).reduce(function (evaluatedPaths, appName) {
    var appPath = apps[appName].appPath;


    if (!appPath || typeof appPath !== 'string') {
      return evaluatedPaths;
    }

    var params = _pathToRegexp2.default.parse(apps[appName].appPath).filter(function (key) {
      return (typeof key === 'undefined' ? 'undefined' : (0, _typeof3.default)(key)) === 'object';
    }).map(function (_ref) {
      var name = _ref.name;
      return name;
    });

    return (0, _assign2.default)({}, evaluatedPaths, (0, _defineProperty3.default)({}, appName, {
      name: appName,
      path: appPath,
      params: params,
      checker: (0, _pathToRegexp2.default)(appPath)
    }));
  }, {});
}

function getAppNameFromPath(evaluatedPaths, path) {
  return (0, _keys2.default)(evaluatedPaths).find(function (appName) {
    var evaluatedPath = evaluatedPaths[appName];
    return evaluatedPath ? evaluatedPath.checker.exec(path) : false;
  });
}

function evalPathParams(evaluatedPath, path) {
  var match = evaluatedPath.checker.exec(path);

  if (!match) {
    return null;
  }

  return match.filter(function (token, idx) {
    return idx > 0;
  }).reduce(function (params, token, idx) {
    return (0, _assign2.default)({}, params, (0, _defineProperty3.default)({}, evaluatedPath.params[idx], token));
  }, {});
}