'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.retry = exports.delay = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var delay = exports.delay = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
    var timeout = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _constants.DEFAULT_TIMEOUT;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            return _context.abrupt('return', new _promise2.default(function (resolve) {
              return setTimeout(resolve, timeout);
            }));

          case 1:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function delay() {
    return _ref.apply(this, arguments);
  };
}();

var retry = exports.retry = function () {
  var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(iteratee, interval) {
    var timeout = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : _constants.DEFAULT_TIMEOUT;
    var firstTry, retries, iterations;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            firstTry = iteratee();

            if (!firstTry) {
              _context2.next = 3;
              break;
            }

            return _context2.abrupt('return', firstTry);

          case 3:
            retries = timeout / interval;
            iterations = 0;
            return _context2.abrupt('return', new _promise2.default(function (resolve) {
              var iterator = setInterval(function () {
                iterations += 1;

                var iterateeReturn = iteratee();

                if (iterateeReturn || iterations >= retries) {
                  resolve(iterateeReturn);
                  clearInterval(iterator);
                }
              }, interval);
            }));

          case 6:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function retry(_x3, _x4) {
    return _ref2.apply(this, arguments);
  };
}();

var _constants = require('../constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }